//+------------------------------------------------------------------+
//|                                                         Calc.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
/*     .
     :    3    OPEN, STOP, PROFIT;
            
   (OPEN),   (STOP)  - (PROFIT).   
      ,    (calc_lots)  
     (comission)   CFD,     
    (      ,  CFD    
   ).           
    ( ) ,   ,     
              
    .
     XXXYYY     
     USDYYY  XXXUSD (  GPBJPY      
     USDJPY). 
            .*/
//+---------------------------------------------------------------------------------+
#property description "   /  "
#property description  "  ,    "
#property description  "OPEN, STOP, PROFIT   "
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//--- input parameters
input double   calc_lots=0.01;
input double   comission=0.0;
input color    clrOpen=clrWhite;
input color    clrStop=clrYellow;
input color    clrProfit=clrAqua;
input color    clrStopout=clrRed;
#include <Trade\AccountInfo.mqh>
#include <Trade\SymbolInfo.mqh>
#include <ChartObjects\ChartObjectsLines.mqh>
CAccountInfo account;
CSymbolInfo  sym;
CChartObjectHLine OPEN,STOP,PROFIT,STOPOUT;  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   sym.Name(_Symbol);
   sym.Refresh();
   init();
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (const int rates_total,      //   price[]
                 const int prev_calculated,  //     
                 const int begin,            //    
                 const double& price[]       //   
   )
   {
    return(rates_total);
   }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_OBJECT_DRAG)
    if(sparam=="OPEN"||sparam=="STOP"||sparam=="PROFIT")
     start();
  }
//+------------------------------------------------------------------+
double stopout_level; // 
double proff, preproff, preloss, kurs;
double loss, start_margin, calc_margin,stopout_lvl2, stopout_lvl, marginsum, marginsum2;
double tikk_v;// 
double tikk_s;// 
ENUM_SYMBOL_CALC_MODE tikk_m;//  
double tikk_l;// 

string comnts="";

ENUM_ACCOUNT_INFO_INTEGER leverage_lev;//
// 
int init()
  {
  SymbolSelect("EURUSD",true);
  SymbolSelect("GPBUSD",true);
  SymbolSelect("USDJPY",true);
  tikk_v = sym.TickValue();
  tikk_s = sym.TickSize();
  tikk_m = sym.TradeCalcMode();
  tikk_l = sym.ContractSize();
  
  stopout_level = account.MarginStopOut();
  leverage_lev =(ENUM_ACCOUNT_INFO_INTEGER) account.Leverage();
  start_margin = calc_lots*sym.MarginInitial();
  calc_margin = calc_lots*sym.MarginMaintenance();
  if ( calc_margin <= 0) 
    calc_margin=calc_lots*tikk_l/leverage_lev;
  sym.RefreshRates();
  double bid=sym.Bid();
  double eurusd_k = SymbolInfoDouble("EURUSD",SYMBOL_BID );
  double gpbusd_k = SymbolInfoDouble("GPBUSD",SYMBOL_BID);
  double usdjpy_k = 1/SymbolInfoDouble("USDJPY",SYMBOL_BID);
  //          (Broco):
   kurs = 1;

   //    
   ChartSetInteger(0,CHART_SHOW_OBJECT_DESCR,true);
   if (ObjectFind(0,"OPEN")== -1) OPEN.Create(ChartID(),"OPEN",0,bid);
   if (ObjectFind(0,"STOP")== -1) STOP.Create(ChartID(),"STOP",0,bid-200*_Point);
   if (ObjectFind(0,"PROFIT")== -1) PROFIT.Create(ChartID(),"PROFIT",0,bid+200*_Point);
   if (ObjectFind(0,"STOPOUT")== -1) STOPOUT.Create(ChartID(),"STOPOUT",0,-1.0);
   OPEN.Color(clrOpen);
   STOP.Color(clrStop);
   PROFIT.Color(clrProfit);
   STOPOUT.Color(clrStopout);
   OPEN.Selectable(true);
   STOP.Selectable(true);
   PROFIT.Selectable(true);
   OPEN.Selected(true);
   STOP.Selected(true);
   PROFIT.Selected(true);
   return (0);
  }
 void OnDeinit(const int reason)
  {
    Comment("");
  };
      
//                               
int start()
  {
   sym.RefreshRates();
   double open=OPEN.Price(0);
   double profit=PROFIT.Price(0);
   double stop=STOP.Price(0);
   double balance=account.Balance();
   double bid=sym.Bid();
 //  
   preproff = kurs*MathAbs(open-profit);
   preloss = kurs*MathAbs(open-stop);
   marginsum = ((100-stopout_level)/100)*MathAbs(balance-calc_margin);
   switch (tikk_m)
   {
 case SYMBOL_CALC_MODE_FOREX: // Forex
  if (StringSubstr(_Symbol,3,3)=="USD") // XXXUSD
   {
    proff = preproff*calc_lots*tikk_l;
    loss = preloss*calc_lots*tikk_l;
    stopout_lvl = open + marginsum/(calc_lots*tikk_l);
    stopout_lvl2 = open - marginsum/(calc_lots*tikk_l);
    if (start_margin<=0)start_margin = calc_lots*tikk_l/leverage_lev;
   }
  if (StringSubstr(Symbol(), 0, 3)=="USD") //  USDXXX
   {
    proff = preproff*calc_lots*tikk_l/profit;
    loss = preloss*calc_lots*tikk_l/stop;
    marginsum = ((100-stopout_level)/100)*MathAbs(balance-calc_margin/bid);
    marginsum2 = ((100-stopout_level)/100)*MathAbs(balance-calc_margin/bid);
    stopout_lvl =open + marginsum/(calc_lots*tikk_l/bid);
    stopout_lvl2 =open - marginsum/(calc_lots*tikk_l/bid);
    if (start_margin==0)start_margin = calc_margin/bid;
   }
 
  if (StringFind(_Symbol, "USD", 0) == -1) // 
   {
    if (SymbolInfoDouble("USD"+StringSubstr(_Symbol, 3, 3),SYMBOL_BID)>0)
     {
      double tmpinfo = SymbolInfoDouble("USD"+StringSubstr(_Symbol, 3, 3),SYMBOL_BID);
      marginsum = ((100-stopout_level)/100)*MathAbs(balance-calc_margin/tmpinfo);
      proff = preproff*calc_lots*tikk_l/tmpinfo ;
      loss = preloss*calc_lots*tikk_l/tmpinfo ;
      stopout_lvl = open + marginsum/(calc_lots*tikk_l/tmpinfo);
      stopout_lvl2 =open - marginsum/(calc_lots*tikk_l/tmpinfo);
      if (start_margin<=0)start_margin = (calc_lots*tikk_l/leverage_lev)/tmpinfo;
     }
    else 
     {
      if (SymbolInfoDouble(StringSubstr(_Symbol, 0, 3)+"USD",SYMBOL_BID)>0)
       {
        double tmpinfo2 = SymbolInfoDouble(StringSubstr(_Symbol, 0, 3)+"USD",SYMBOL_BID);
        marginsum = ((100-stopout_level)/100)*MathAbs(balance-calc_margin*tmpinfo2);
        proff = preproff*calc_lots*tikk_l*tmpinfo2 ;
        loss = preloss*calc_lots*tikk_l*tmpinfo2 ;
        stopout_lvl = open + marginsum/(calc_lots*tikk_l*tmpinfo2);
        stopout_lvl2 = open - marginsum/(calc_lots*tikk_l*tmpinfo2);
        if (start_margin<=0)start_margin = (calc_lots*tikk_l/leverage_lev)*tmpinfo2;
       }
      else
       {
        double xxx = 1;
        if (StringSubstr(Symbol(), 3, 3)=="CAD") xxx=1.2175;
        if (StringSubstr(Symbol(), 3, 3)=="JPY") xxx=91.425;
        if (StringSubstr(Symbol(), 3, 3)=="CHF") xxx=1.1631;
        if (StringSubstr(Symbol(), 3, 3)=="AUD") xxx=1/0.6800;
        if (StringSubstr(Symbol(), 3, 3)=="NZD") xxx=1/0.54;
        if (StringSubstr(Symbol(), 3, 3)=="GPB") xxx=1/1.49;
        if (StringSubstr(Symbol(), 3, 3)=="EUR") xxx=1/1.3015;
        marginsum = ((100-stopout_level)/100)*MathAbs(balance-calc_margin/xxx);
        proff = preproff*calc_lots*tikk_v/tikk_s;
        loss = preloss*calc_lots*tikk_v/tikk_s;
        stopout_lvl =  open + marginsum/(calc_lots*tikk_v/(tikk_s/xxx));
        stopout_lvl2 = open - marginsum/(calc_lots*tikk_v/(tikk_s/xxx));
       } 
  }
  
 }
 break;
case SYMBOL_CALC_MODE_CFD: //CFD 
   proff = preproff*calc_lots*tikk_l - (comission/100)*calc_lots*open;
   loss  = preloss*calc_lots*tikk_l  + (comission/100)*calc_lots*open;
   stopout_lvl = open + (marginsum-(comission/100)*calc_lots*open)/(calc_lots*tikk_l);
   stopout_lvl2 = open - (marginsum-(comission/100)*calc_lots*open)/(calc_lots*tikk_l);
 break;
 default: // 
   proff =( preproff*calc_lots*tikk_v/tikk_s) - (calc_lots*comission);
   loss = (  preloss*calc_lots*tikk_v/tikk_s) + (calc_lots*comission);
   stopout_lvl = open + (marginsum/kurs-calc_lots*comission)/(calc_lots*tikk_v/tikk_s);
   stopout_lvl2 = open - (marginsum/kurs-calc_lots*comission)/(calc_lots*tikk_v/tikk_s);
   marginsum = marginsum/kurs;
 }
//  
 if (open>profit)
   {
    if (ObjectFind(0,"STOPOUT") == -1) 
      STOPOUT.Create(ChartID(),"STOPOUT",0,stopout_lvl);
    STOPOUT.Price(0,stopout_lvl);  
   }   
 else
   {
    if (ObjectFind(0,"STOPOUT") == -1)
       STOPOUT.Create(ChartID(),"STOPOUT",0,stopout_lvl2);
    STOPOUT.Price(0,stopout_lvl2);    
    }   

 //    
  ObjectSetString(0,"STOPOUT",OBJPROP_TEXT, "  -"+DoubleToString(marginsum, 2)+"USD");
  ObjectSetString(0,"OPEN",OBJPROP_TEXT,"Open "+DoubleToString(calc_lots,2)+" ");
  ObjectSetString(0,"STOP",OBJPROP_TEXT, "Stop "+DoubleToString(loss, 2));
  ObjectSetString(0,"PROFIT",OBJPROP_TEXT, "Profit "+DoubleToString(proff, 2));
 
//         
  comnts = " "+ DoubleToString(calc_lots,2) + "  : " + DoubleToString(proff,2) +" ("+DoubleToString(proff*100/account.Equity(), 2)+"%) "+ " : " + DoubleToString(loss, 2)+" ("+DoubleToString(loss*100/account.Equity(), 2)+"%) ";
  if (start_margin>0) comnts = comnts + " : "+DoubleToString(start_margin,2)+" USD";
  if (leverage_lev>0) comnts = comnts + " : " + DoubleToString(leverage_lev,2);
  Comment(comnts);
  return(0);
  }
